/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"

#line 1 "bi_poll.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

size_t last_poll_host_loc;
size_t last_poll_send_loc;
size_t last_poll_recv_loc;
size_t cache_used_loc;

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	char *s;

	s = host_addr ? strcpy(heap_reserve(env, strlen(host_addr) + 1),
			       host_addr) : NULL;
	*env_var_ref(env, last_poll_host_loc) = s;
	s = send ? strcpy(heap_reserve(env, strlen(send) + 1), send) : NULL;
	*env_var_ref(env, last_poll_send_loc) = s;
	s = recv ? strcpy(heap_reserve(env, strlen(recv) + 1), recv) : NULL;
	*env_var_ref(env, last_poll_recv_loc) = s;
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_var_ref(env, cache_used_loc) = (STKVAL) value;
}


void
#line 47
bi_stdpoll(eval_environ_t env)
#line 47 "bi_poll.m4"
{
#line 47
	char * email = (char *) get_arg(env, 2);
#line 47
        char * ehlo = (char *) get_arg(env, 1);
#line 47
        char * mailfrom = (char *) get_arg(env, 0);
#line 47
        
#line 47
        adjust_stack(env, 3);
#line 47
	if (prog_trace_option)
#line 47
		prog_trace(env, "stdpoll %s %s %s",
#line 47
	                   email, ehlo, mailfrom);
#line 47

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
	if (!mf_resolved (rc)) {
		if (env_catch(env, rc) == 0)
			return;
		else
			runtime_error(env, "unhandled exception %s",
				      mf_status_str(rc));
	}
			
	push(env, (STKVAL) rc);	
}
}

#line 70
void
#line 70
bi_strictpoll(eval_environ_t env)
#line 70 "bi_poll.m4"
{
#line 70
	char * host = (char *) get_arg(env, 3);
#line 70
        char * email = (char *) get_arg(env, 2);
#line 70
        char * ehlo = (char *) get_arg(env, 1);
#line 70
        char * mailfrom = (char *) get_arg(env, 0);
#line 70
        
#line 70
        adjust_stack(env, 4);
#line 70
	if (prog_trace_option)
#line 70
		prog_trace(env, "strictpoll %s %s %s %s",
#line 70
	                   host, email, ehlo, mailfrom);
#line 70

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
	
	if (!mf_resolved (rc)) {
		if (env_catch(env, rc) == 0)
			return;
		else
			runtime_error(env, "unhandled exception %s",
				      mf_status_str(rc));
	}
	
	push(env, (STKVAL) rc);	
}
}

#line 96
void
#line 96
bi__pollhost(eval_environ_t env)
#line 96 "bi_poll.m4"
{
#line 96
	char * host = (char *) get_arg(env, 3);
#line 96
        char * email = (char *) get_arg(env, 2);
#line 96
        char * ehlo = (char *) get_arg(env, 1);
#line 96
        char * mailfrom = (char *) get_arg(env, 0);
#line 96
        
#line 96
        adjust_stack(env, 4);
#line 96
	if (prog_trace_option)
#line 96
		prog_trace(env, "_pollhost %s %s %s %s",
#line 96
	                   host, email, ehlo, mailfrom);
#line 96

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

	if (!mf_resolved (rc)) {
		if (env_catch(env, rc) == 0)
			return;
		else
			runtime_error(env, "unhandled exception %s",
				      mf_status_str(rc));
	}
	push(env, (STKVAL) rc);	
}
}

#line 121
void
#line 121
bi__pollmx(eval_environ_t env)
#line 121 "bi_poll.m4"
{
#line 121
	char * domain = (char *) get_arg(env, 3);
#line 121
        char * email = (char *) get_arg(env, 2);
#line 121
        char * ehlo = (char *) get_arg(env, 1);
#line 121
        char * mailfrom = (char *) get_arg(env, 0);
#line 121
        
#line 121
        adjust_stack(env, 4);
#line 121
	if (prog_trace_option)
#line 121
		prog_trace(env, "_pollmx %s %s %s %s",
#line 121
	                   domain, email, ehlo, mailfrom);
#line 121

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

	if (!mf_resolved (rc)) {
		if (env_catch(env, rc) == 0)
			return;
		else
			runtime_error(env, "unhandled exception %s",
				      mf_status_str(rc));
	}
	push(env, (STKVAL) rc);	
}
}

#line 153

#line 153
void
#line 153
poll_init_builtin()
#line 153
{
#line 153
	#line 47 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, 0, rettype_number, 3, rettype_string, rettype_string, rettype_string);
#line 70 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, 0, rettype_number, 4, rettype_string, rettype_string, rettype_string, rettype_string);
#line 96 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, 0, rettype_number, 4, rettype_string, rettype_string, rettype_string, rettype_string);
#line 121 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, 0, rettype_number, 4, rettype_string, rettype_string, rettype_string, rettype_string);

#line 153 "bi_poll.m4"
	last_poll_host_loc =
#line 153
  	     builtin_variable_install("last_poll_host", rettype_string)->off;
#line 153
	last_poll_send_loc =
#line 153
	     builtin_variable_install("last_poll_send", rettype_string)->off;
#line 153
	last_poll_recv_loc =
#line 153
	     builtin_variable_install("last_poll_recv", rettype_string)->off;
#line 153
	cache_used_loc =
#line 153
	     builtin_variable_install("cache_used", rettype_string)->off;
#line 153
		
#line 153
}
#line 0

#line 0

