/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"

#line 1 "bi_string.m4"
/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

void
#line 19
bi_toupper(eval_environ_t env)
#line 19 "bi_string.m4"
{
#line 19
	char * string = (char *) get_arg(env, 0);
#line 19
        
#line 19
        adjust_stack(env, 1);
#line 19
	if (prog_trace_option)
#line 19
		prog_trace(env, "toupper %s",
#line 19
	                   string);
#line 19

{
	char *p;
	for (p = string; *p; p++)
		*p = toupper(*p);
	push(env, string);
}
}

void
#line 28
bi_tolower(eval_environ_t env)
#line 28 "bi_string.m4"
{
#line 28
	char * string = (char *) get_arg(env, 0);
#line 28
        
#line 28
        adjust_stack(env, 1);
#line 28
	if (prog_trace_option)
#line 28
		prog_trace(env, "tolower %s",
#line 28
	                   string);
#line 28

{
	char *p;
	for (p = string; *p; p++)
		*p = tolower(*p);
	push(env, string);
}
}

void
#line 37
bi_length(eval_environ_t env)
#line 37 "bi_string.m4"
{
#line 37
	char * string = (char *) get_arg(env, 0);
#line 37
        
#line 37
        adjust_stack(env, 1);
#line 37
	if (prog_trace_option)
#line 37
		prog_trace(env, "length %s",
#line 37
	                   string);
#line 37

{
	push(env, (STKVAL) strlen(string));
}
}

void
#line 43
bi_substring(eval_environ_t env)
#line 43 "bi_string.m4"
{
#line 43
	char * string = (char *) get_arg(env, 2);
#line 43
        long  start = (long ) get_arg(env, 1);
#line 43
        long  end = (long ) get_arg(env, 0);
#line 43
        
#line 43
        adjust_stack(env, 3);
#line 43
	if (prog_trace_option)
#line 43
		prog_trace(env, "substring %s %lu %lu",
#line 43
	                   string, start, end);
#line 43

{
	long len = strlen(string);
	char *s;
	
	if (end < 0)
		end = len - 1;
	if (end < start) {
		long t = end;
		end = start;
		start = t;
	}

	if (start >= len || end >= len) {
		if (env_catch(env, mf_range) == 0)
			return;
		else
			runtime_error(env, "substring: argument out of range");
	}
	
	len = end - start + 1;
	s = heap_reserve(env, len + 1);
	memcpy(s, string + start, len);
	s[len] = 0;
	
	push(env, (STKVAL)s);
}
}


#line 72
void
#line 72
string_init_builtin()
#line 72
{
#line 72
	#line 19 "bi_string.m4"
va_builtin_install_ex("toupper", bi_toupper, 0, 0, rettype_number, 1, rettype_string);
#line 28 "bi_string.m4"
va_builtin_install_ex("tolower", bi_tolower, 0, 0, rettype_number, 1, rettype_string);
#line 37 "bi_string.m4"
va_builtin_install_ex("length", bi_length, 0, 0, rettype_number, 1, rettype_string);
#line 43 "bi_string.m4"
va_builtin_install_ex("substring", bi_substring, 0, 0, rettype_string, 3, rettype_string, rettype_number, rettype_number);

#line 72 "bi_string.m4"
		
#line 72
}
#line 0

#line 0

